#!/usr/bin/perl -w
#
use strict;
use XML::Parser;

my $parser = XML::Parser->new(Style => 'Stream', Pkg => 'MySubs');
if (@ARGV > 0) {
    foreach my $arg (@ARGV) {
        $parser->parsefile($arg);
    }
} else {
    print "USAGE: ./texttagger.pl XMLFILE\n";
}


{
    package MySubs;

    sub StartTag {
        my ($expat, $name) = @_;
        print "<$name>";
    }

    sub EndTag {
        my ($expat, $name) = @_;
        print "</$name>";
    }

    sub Text {
        my @data = split;
        foreach my $word (@data) {
            $word =~ tr/a-zA-Z0-9_.//cd;
            if ($word =~ /^[a-zA-Z_]/) {
                print "<$word/>";
            } else {
                print "<digit_$word/>";
            }
        }
        print "\n";
    }
}

# EOF
