package unot;

public class SerializeUnotPatternWriter extends UnotPatternWriter {
	public static final String signature = "serial";
	static final String writerName = signature+" SerializeUnotPatternWriter";

	DocSet docSet = null; 

	public SerializeUnotPatternWriter(DocSet docSet) {
		if (docSet == null) {
			System.out.println("error: UnotPatternWriter:null docSet!");
			System.exit(1);
		}
		this.docSet = docSet;
	};

	void writeIntList(StringBuffer strBuf, int[] list) {
		strBuf.append(list.length+" ");
        for (int i = 0; i < list.length; i++) {
            strBuf.append(list[i]+" ");
        }
	}

	public String getName() { return writerName; }

	void getCodeString(StringBuffer strBuf, Pattern pattern) {
		strBuf.append(pattern.getCodeSize()+" ");
        for (int i = 0; i < pattern.getCodeSize(); i++) {
			DLpair pair = pattern.getNodeAt(i);
            strBuf.append(pair.getDepth()+" "+pair.getLabel()+" ");
            //strBuf.append(this.code[i].toString());
        }
	}

	String writeTree(Pattern pattern) {
		StringBuffer strBuf = new StringBuffer();

        strBuf.append("@size "+pattern.getCodeSize()+"\n");
        strBuf.append("@code ");
		getCodeString(strBuf, pattern);
        strBuf.append("\n");

        strBuf.append("@right ");
		writeIntList(strBuf, pattern.getRight()); 
        strBuf.append("\n");

		return strBuf.toString();
	}

	String writeUnotTree(UnotPattern pattern) {
		StringBuffer strBuf = new StringBuffer();

        strBuf.append("@size "+pattern.getCodeSize()+"\n");
        strBuf.append("@code ");
		getCodeString(strBuf, pattern);
        strBuf.append("\n");

		int[] list = null;

        strBuf.append("@left ");
		writeIntList(strBuf, pattern.getLeft()); 
        strBuf.append("\n");

        strBuf.append("@right ");
		writeIntList(strBuf, pattern.getRight()); 
        strBuf.append("\n");

        strBuf.append("@lcp ");
		writeIntList(strBuf, pattern.getLcp()); 
        strBuf.append("\n");

        strBuf.append("@copydepth "+pattern.getCopyDepth()+"\n");

        //strBuf.append("\n@endpattern\n");

		return strBuf.toString();
	}

}

//EOF 

